models/Eventos.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "eventos".
 *
 * @property int $idEvento
 * @property string|null $nombrEvento
 * @property string|null $fecha
 * @property string|null $lugar
 * @property string|null $categoria
 * @property string|null $descripcion
 * @property string|null $imagenE
 * @property int|null $idPatrocinador
 * @property int|null $idAgente
 *
 * @property Asisten[] $asistens
 * @property Experiencias[] $experiencias
 * @property Financian[] $financians
 * @property Agentes $idAgente0
 * @property Patrocinadores $idPatrocinador0
 * @property Patrocinadores[] $idPatrocinadors
 * @property Usuarios[] $idUsuarios
 */
class Eventos extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'eventos';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['fecha'], 'safe'],
            [['idPatrocinador', 'idAgente'], 'integer'],
            [['precio'], 'number'],
            [['nombrEvento', 'lugar', 'categoria'], 'string', 'max' => 100],
            [['descripcion'], 'string', 'max' => 250],
            [['imagenE'], 'string', 'max' => 500],
            [['idAgente'], 'exist', 'skipOnError' => true, 'targetClass' => Agentes::class, 'targetAttribute' => ['idAgente' => 'idAgente']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'idEvento' => 'Id Evento',
            'nombrEvento' => 'Nombr Evento',
            'fecha' => 'Fecha',
            'lugar' => 'Lugar',
            'categoria' => 'Categoria',
            'descripcion' => 'Descripcion',
            'imagenE' => 'Imagen E',
            'precio' => 'Precio',
            'idAgente' => 'Id Agente',
        ];
    }


    /**
     * Gets query for [[Experiencias]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getExperiencias()
    {
        return $this->hasMany(Experiencias::class, ['idEvento' => 'idEvento']);
    }

    /**
     * Gets query for [[IdAgente0]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getIdAgente0()
    {
        return $this->hasOne(Agentes::class, ['idAgente' => 'idAgente']);
    }

    /**
     * Gets query for [[IdUsuarios]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getIdUsuarios()
    {
        return $this->hasMany(Usuarios::class, ['idUsuario' => 'idUsuario'])->viaTable('asisten', ['idEvento' => 'idEvento']);
    }
}

controllers/EventosController.php
<?php
namespace app\controllers;

use app\models\Eventos;
use app\models\Compras;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use Yii;
use yii\web\Response;

/**
 * EventosController implements the CRUD actions for Eventos model.
 */
class EventosController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Eventos models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Eventos::find()
                ->where(['>=', 'fecha', date('Y-m-d')]) // Filtrar eventos que no hayan pasado
                ->orderBy(['fecha' => SORT_ASC]), // Ordenar por fecha ascendente
            'pagination' => [
                'pageSize' => 6, // Mostrar solo 6 eventos por página
            ],
        ]);
    
        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }
    
    /**
     * Displays a single Eventos model.
     * @param int $idEvento Id Evento
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($idEvento)
    {
        $model = $this->findModel($idEvento);
        $agente = $model->idAgente0; // Obtener el agente relacionado

        // Obtener los teléfonos del agente
        $telefonosAgente = $agente ? $agente->telefonosagentes : [];

        $compraModel = new Compras(); // Crear una instancia del modelo Compras

        return $this->render('view', [
            'model' => $model,
            'agente' => $agente,
            'telefonosAgente' => $telefonosAgente,
            'compraModel' => $compraModel, // Pasar la variable a la vista
        ]);
    }

    /**
     * Creates a new Eventos model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Eventos();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'idEvento' => $model->idEvento]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Eventos model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $idEvento Id Evento
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($idEvento)
    {
        $model = $this->findModel($idEvento);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'idEvento' => $model->idEvento]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Eventos model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $idEvento Id Evento
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($idEvento)
    {
        $this->findModel($idEvento)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Eventos model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $idEvento Id Evento
     * @return Eventos the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($idEvento)
    {
        if (($model = Eventos::findOne(['idEvento' => $idEvento])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }

    /** Buscador */
    public function actionBuscar()
    {
        Yii::$app->response->format = Response::FORMAT_JSON;

        $query = Yii::$app->request->get('query');
        $result = [];

        if ($query) {
            $result = Eventos::find()
                ->where(['like', 'nombrEvento', $query])
                ->all();
        }

        return $this->renderPartial('_resultados', ['resultados' => $result]);
    }
}

views/eventos/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\Eventos $model */
/** @var yii\widgets\ActiveForm $form */
?>

<div class="eventos-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'nombrEvento')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'fecha')->textInput() ?>

    <?= $form->field($model, 'lugar')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'categoria')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'descripcion')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'imagenE')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'idPatrocinador')->textInput() ?>

    <?= $form->field($model, 'idAgente')->textInput() ?>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/eventos/_resultados.php
<?php

use yii\helpers\Html;
use yii\helpers\Url;

/** @var yii\web\View $this */
/** @var app\models\Eventos[] $resultados */

?>

<?php if (!empty($resultados)) : ?>
    <div class="row tarjetas">
        <?php foreach ($resultados as $evento) : ?>
            <div class="col-12 col-md-4 mb-4">
                <a href="<?= Url::to(['eventos/view', 'idEvento' => $evento->idEvento]) ?>" class="card-link">
                    <div class="card contenedor">
                        <img src="<?= Html::encode($evento->imagenE) ?>" alt="<?= Html::encode($evento->nombrEvento) ?>" class="card-img-top imagen-evento">
                        <div class="card-body">
                            <p class="card-text fecha"><?= Html::encode($evento->fecha) ?></p>
                            <h4 class="card-title titulo"><?= Html::encode($evento->nombrEvento) ?></h4>
                        </div>
                    </div>
                </a>
            </div>
        <?php endforeach; ?>
    </div>
<?php endif; ?>

views/eventos/create.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** @var app\models\Eventos $model */

$this->title = 'Create Eventos';
$this->params['breadcrumbs'][] = ['label' => 'Eventos', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="eventos-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/eventos/index.php
<?php

use yii\helpers\Html;
use yii\helpers\Url;
use yii\widgets\LinkPager;

/** @var yii\web\View $this */
/** @var yii\data\ActiveDataProvider $dataProvider */

$this->title = 'Eventos';

// Función para convertir la fecha
function formatearFecha($fecha)
{
    setlocale(LC_TIME, 'es_ES.UTF-8'); // Establecer la configuración regional en español
    $timestamp = strtotime($fecha);
    return strftime('%e de %B, %Y', $timestamp);
}
?>

<div class="container">
    <div class="eventos-home">
        <div class="row">
            <div class="col">
                <h1 class="text-center titulo-busqueda-eventos"><span>Buscar Eventos</span></h1>
                <form id="buscador-form" method="GET">
                    <input type="text" name="query" id="query" placeholder="Buscar eventos" class="form-control buscador-pequeno">
                </form>
                <div id="resultados"></div>
                <p id="no-resultados" style="display:none;">No se encontraron eventos.</p>
            </div>
        </div>
       
        <div class="row">
            <div class="burguer">
                <div class="container">
                    <div class="row tarjetas" id="resultados-eventos">
                        <?php if ($dataProvider->getCount() > 0) : ?>
                            <?php foreach ($dataProvider->getModels() as $evento) : ?>
                                <div class="col-12 col-md-4 mb-4">
                                    <a href="<?= Url::to(['eventos/view', 'idEvento' => $evento->idEvento]) ?>" class="card-link">
                                        <div class="card contenedor">
                                            <img src="<?= Html::encode($evento->imagenE) ?>" alt="<?= Html::encode($evento->nombrEvento) ?>" class="card-img-top imagen-evento" onerror="this.onerror=null;this.src='<?= Url::to('@web/images/default.png') ?>';">
                                            <div class="card-body">
                                                <p class="card-text fecha"><?= Html::encode(formatearFecha($evento->fecha)) ?></p>
                                                <h4 class="card-title titulo"><?= Html::encode($evento->nombrEvento) ?></h4>
                                            </div>
                                        </div>
                                    </a>
                                </div>
                            <?php endforeach; ?>
                        <?php else : ?>
                            <p>No hay eventos disponibles.</p>
                        <?php endif; ?>
                    </div>
                    <div class="pagination-wrapper">
                        <?= LinkPager::widget([
                            'pagination' => $dataProvider->pagination,
                        ]); ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<script>
    $(document).ready(function() {
        $('#query').on('keyup', function() {
            var query = $(this).val().trim();
            if (query.length === 0) {
                $('#resultados-eventos').show(); // Muestra los eventos iniciales si no hay búsqueda
                $('#resultados').empty();
                $('#no-resultados').hide();
                return;
            } else {
                $('#resultados-eventos').hide(); // Oculta los eventos iniciales
            }
            $.ajax({
                url: '<?= Url::to(['eventos/buscar']) ?>',
                type: 'GET',
                data: {
                    query: query
                },
                success: function(response) {
                    $('#resultados').html(response);
                    if (!$.trim(response)) {
                        $('#no-resultados').show();
                    } else {
                        $('#no-resultados').hide();
                    }
                }
            });
        });
    });
</script>

views/eventos/update.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** @var app\models\Eventos $model */

$this->title = 'Update Eventos: ' . $model->idEvento;
$this->params['breadcrumbs'][] = ['label' => 'Eventos', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->idEvento, 'url' => ['view', 'idEvento' => $model->idEvento]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="eventos-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/eventos/view.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\Eventos $model */
/** @var app\models\Agentes $agente */
/** @var app\models\Telefonosagentes[] $telefonosAgente */

$this->title = $model->nombrEvento;
\yii\web\YiiAsset::register($this);
?>
<div class="eventos-view">

    <div class="container p-0">

    <div class="single-news-hero">
            <div class="image"></div>
            <div class="row row-1 detalle-evento" style="position: relative; height:100%;">
                <div class="col" style="position: absolute; bottom: 0;">
                    <div class="fecha"><?= Html::encode(date('d-m-Y', strtotime($model->fecha))) ?></div>
                    <h1><?= Html::encode($this->title) ?></h1>
                    <div class="categoria"><?= Html::encode($model->categoria) ?></div>
                </div>
            </div>
        </div>

        <div class="row mx-auto mt-4">
            <div class="col">
                <p class="descripcion"><?= Html::encode($model->descripcion) ?></p>
                <p class="precio"><strong>Precio:</strong> <?= Html::encode(number_format($model->precio, 2)) ?>€</p>

                <div class="agente-info">
                    <?php if ($agente) : ?>
                        <p><strong>Agente del evento:</strong> <?= Html::encode($agente->nombreA) ?></p>
                        <p><strong>Teléfonos:</strong></p>
                        <ul>
                            <?php foreach ($telefonosAgente as $telefono) : ?>
                                <li><?= Html::encode($telefono->telefonoAgente) ?></li>
                            <?php endforeach; ?>
                        </ul>
                    <?php else : ?>
                        <p>No hay información del agente disponible.</p>
                    <?php endif; ?>
                </div>

                <!--Mandar info al carrito -->
                <?php if (Yii::$app->user->isGuest) : ?>
                    <p><?= Html::a('Agregar al carrito', ['site/login'], ['class' => 'btn btn-primary']) ?></p>
                <?php else : ?>
                    <?php $form = ActiveForm::begin(['action' => ['compras/add']]); ?>
                    <?= Html::hiddenInput('id', $model->idEvento) ?>
                    <?= Html::hiddenInput('cantidad', 1) ?>
                    <div class="form-group">
                        <?= Html::submitButton('Añadir entrada al carrito', ['class' => 'btn btn-primary']) ?>
                    </div>
                    <?php ActiveForm::end(); ?>
                <?php endif; ?>

            </div>
        </div>
    </div>

</div>